<?php
/**
 * Created by PhpStorm.
 * User: root
 * Date: 17/03/15
 * Time: 3:05 PM
 */

namespace Drupal\node_expire_extras\Module\Interval;


/**
 * Defines helper class for expire dates.
 */
class IntervalStr implements IntervalStrInterface  {

  /**
   * Multiplier.
   *
   * @var int
   */
  protected $multiplier;

  /**
   * Interval.
   *
   * @var int
   */
  protected $interval;

  /**
   * Constructs an IntervalStr object.
   *
   * @param int $multiplier
   *   Interval multiplier.
   * @param int $interval
   *   Interval.
   */
  public function __construct($multiplier, $interval) {
    $this->multiplier = $multiplier;
    $this->interval = $interval;
  }

  /**
   * Makes interval string.
   */
  public function GetIntervalStr() {

    // Sign.
    $date_str = "+ ";
    if ($this->interval < 0) {
      $date_str = "- ";
    }

    // Value.
    $abs_multiplier = abs($this->multiplier);
    $date_str .= $abs_multiplier . " ";

    // Interval.
    switch ($this->interval) {
      case IntervalEnumInterface::DAY:
        $date_str .= 'day';
        break;

      case IntervalEnumInterface::WEEK:
        $date_str .= 'week';
        break;

      case IntervalEnumInterface::MONTH:
        $date_str .= 'month';
        break;

      case IntervalEnumInterface::YEAR:
        $date_str .= 'year';
        break;

      default:
        // Year.
        $date_str .= "year";
        break;
    }

    if ($abs_multiplier > 1) {
      $date_str .= "s";
    }

    return $date_str;

  }

}
